varying vec3 interpolatedLocalPosition;

// Source: https://www.shadertoy.com/view/Xsl3Dl
vec3 hash(vec3 p) {
    p = vec3( dot(p, vec3(127.1,311.7, 74.7)),
                dot(p, vec3(269.5,163.3,226.1)),
                dot(p, vec3(113.5,271.9,124.6)));
                
    return -1.0 + 2.0*fract(sin(p)*43758.5453123);
}

// Source: https://www.shadertoy.com/view/Xsl3Dl
float noise(in vec3 p) {
    vec3 i = floor( p );
    vec3 f = fract( p );
    
    //vec3 u = f*f*(3.0-2.0*f);
    vec3 u = f*f*(3.0-2.0*f);

    return mix(mix(mix(dot(hash(i + vec3(0.0,0.0,0.0)), f - vec3(0.0,0.0,0.0)), 
                       dot(hash(i + vec3(1.0,0.0,0.0)), f - vec3(1.0,0.0,0.0)), u.x),
                   mix(dot(hash(i + vec3(0.0,1.0,0.0)), f - vec3(0.0,1.0,0.0)), 
                       dot(hash(i + vec3(1.0,1.0,0.0)), f - vec3(1.0,1.0,0.0)), u.x), u.y),
               mix(mix(dot(hash(i + vec3(0.0,0.0,1.0)), f - vec3(0.0,0.0,1.0)), 
                       dot(hash(i + vec3(1.0,0.0,1.0)), f - vec3(1.0,0.0,1.0)), u.x),
                   mix(dot(hash(i + vec3(0.0,1.0,1.0)), f - vec3(0.0,1.0,1.0)), 
                       dot(hash(i + vec3(1.0,1.0,1.0)), f - vec3(1.0,1.0,1.0)), u.x), u.y), u.z );
}

void main() {
    // -- Task 4 -- Calculate f by combining multiple noise layers using different density
    // Right now it just adds one layer of noise
    float f = 0.0;
    f += 1.0 * noise(3.0 * interpolatedLocalPosition);


    // -- Task 5 -- Determine the color of the fragment.
    // One approach is to use the noise threshold.
    // 		For example if the threshold is smaller than 0 (or some other number) then use blue color (water)
    //		otherwise use green color (land).
    
    // -- Task 6 -- Add the phong or blinn lightning model (keep in mind that there is no ambient light in the space).
    
    // -- Task 7 -- Add specular highlight to the water. Do not add it for land.
    
    // -- Task 8 -- Add atmosphere glow effect (this effect is sometimes called rimlight)
    // Hint: Use the cosine of the angle between the vector towards the camera and surface normal
    //	     The glow should be stronger when the angle is close to 90 degrees.
    
    gl_FragColor = vec4(vec3(f + 0.5), 1.0);
}